<?php
use Tygh\Http;
use Tygh\Registry;
use Tygh\Storage;
use Tygh\Session;

if (!defined('BOOTSTRAP')) { die('Access denied'); }

if (defined('PAYMENT_NOTIFICATION')) {
    if($mode=='result') {
		if($_REQUEST['LMI_PREREQUEST']==1) {
		    echo 'YES';
		    die();
         }
		$LMI_PAYEE_PURSE = $_REQUEST['LMI_PAYEE_PURSE'];
		$LMI_PAYMENT_AMOUNT = $_REQUEST['LMI_PAYMENT_AMOUNT'];
		$LMI_PAYMENT_NO = $_REQUEST['LMI_PAYMENT_NO'];
		
		$LMI_SECRET_KEY = $_REQUEST['LMI_SECRET_KEY'];
		$LMI_MODE = $_REQUEST['LMI_MODE'];
		$LMI_SYS_INVS_NO = $_REQUEST['LMI_SYS_INVS_NO'];
		$LMI_SYS_TRANS_NO = $_REQUEST['LMI_SYS_TRANS_NO'];
		$LMI_SYS_TRANS_DATE = $_REQUEST['LMI_SYS_TRANS_DATE'];
		$LMI_PAYER_PURSE = $_REQUEST['LMI_PAYER_PURSE'];
		$LMI_PAYER_WM = $_REQUEST['LMI_PAYER_WM'];
		$LMI_HASH = $_REQUEST['LMI_HASH'];
		
		$order_info = fn_get_order_info($LMI_PAYMENT_NO);
		$processor_data = fn_get_payment_method_data($order_info['payment_id']);
		$get_orderid = $order_info['order_id'];
		$shop_id = $processor_data['processor_params']['zp_shopid'];
		$shopSecret = $processor_data['processor_params']['zp_secretkey'];
		if(!isset($_REQUEST['LMI_PAYMENT_NO']) ) {
			die("ERROR: EMPTY REQUEST!\n");
		}
		if(!$order_info) {
			die("ERROR: ORDER NOT EXISTS!\n");
		}
		
		$amount= number_format($order_info['total'], 2, '.', ''); 
		$err = FALSE;
		
		if($shop_id!=$_REQUEST['LMI_PAYEE_PURSE']){
	        $err = TRUE;
			$reason='shop id mismatch';
		}
		if($amount!=$LMI_PAYMENT_AMOUNT){
	        $err = TRUE;
			$reason='amount mismatch';
		}


		if(isset($LMI_SECRET_KEY)) {
            if($LMI_SECRET_KEY!=$shopSecret) {
                $err = TRUE;
				$reason='secret key mismatch';
		    }
	    } else {
        $CalcHash = md5($LMI_PAYEE_PURSE.$LMI_PAYMENT_AMOUNT.$LMI_PAYMENT_NO.$LMI_MODE.$LMI_SYS_INVS_NO.$LMI_SYS_TRANS_NO.$LMI_SYS_TRANS_DATE.$shopSecret.$LMI_PAYER_PURSE.$LMI_PAYER_WM);
		    if($LMI_HASH != strtoupper($CalcHash)) {
                $err = TRUE;
				$reason='hash mismatch';
	        }
        }
		echo 'YES';
		if (!$err){
			$pp_response = array();
			$pp_response['order_status'] = 'C';
            $pp_response['reason_text'] = __('completed');
			fn_update_order_payment_info($LMI_PAYMENT_NO, $pp_response);
			fn_change_order_status($LMI_PAYMENT_NO, $pp_response['order_status']);
			fn_finish_payment($LMI_PAYMENT_NO, $pp_response);
			fn_clear_cart($_SESSION['cart']);
		    fn_order_placement_routines('route', $LMI_PAYMENT_NO);
			//die('YES');
        } else { 
		    $pp_response = array();
			$pp_response['order_status'] = 'F';
			$pp_response['reason_text'] = $reason;
			fn_finish_payment($_REQUEST['LMI_PAYMENT_NO'], $pp_response);
			fn_order_placement_routines($_REQUEST['LMI_PAYMENT_NO']);
			fn_clear_cart($_SESSION['cart']);
			die($reason);
  		}
    } elseif($mode=='success') {
	    fn_clear_cart($_SESSION['cart']);
		echo '<script>window.location.href = "index.php?dispatch=orders.search";</script>';
	} elseif($mode=='fail') {
		echo '<script>window.location.href = "index.php?dispatch=orders.search";</script>';
	}
} else {

	$to_pay = number_format($order_info['total'], 2, '.', ''); 
	
	$shop_id = $processor_data['processor_params']['zp_shopid'];
	$init_pass = $processor_data['processor_params']['zp_initpass'];

	$result = "$current_location/$index_script?dispatch=payment_notification.result&payment=zpayment";
	$success = "$current_location/$index_script?dispatch=payment_notification.success&payment=zpayment";
	$fail = "$current_location/$index_script?dispatch=payment_notification.fail&payment=zpayment";
	

	$zpsign = md5($shop_id.$order_id.$to_pay.$init_pass);	
	$desc = "ORDER NO $order_id";

echo <<<EOT
<html>
<body onLoad="javascript: document.process.submit();">

<form id="process" action="https://z-payment.com/merchant.php" name="process" method="get">
	<input type="hidden" name="LMI_PAYEE_PURSE" value="{$shop_id}">
	<input type="hidden" name="LMI_PAYMENT_NO" value="{$order_id}">
	<input type="hidden" name="LMI_PAYMENT_AMOUNT" value="{$to_pay}">
	<input type="hidden" name="CLIENT_EMAIL" value="{$order_info['email']}">
	<input type="hidden" name="ZP_SIGN" value="{$zpsign}">
	<input type="hidden" name="LMI_PAYMENT_DESC" value="{$desc}">
	<input type="hidden" name="payment" value="zpayment">

EOT;
$msg = fn_get_lang_var('text_cc_processor_connection');
$msg = str_replace('[processor]', 'zpayment', $msg);
echo <<<EOT
	</form>
   <p><div align=center>{$msg}</div></p>
 </body>
</html>
EOT;
exit;
}




?>